//+------------------------------------------------------------------+
//|                                                         Fibo.mq4 |
//|                               Copyright 2015, Vladimir Gribachev |
//|                                         http://moneystrategy.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vladimir Gribachev"
#property link      "http://moneystrategy.ru/"
#property version   "1.00"
#property strict


input ENUM_TIMEFRAMES  TFSL     = PERIOD_H4;
input ENUM_TIMEFRAMES TFFIBOFILTER = PERIOD_H4;
input ENUM_TIMEFRAMES TFTRADE = PERIOD_H4;
input int     DepthFilter     = 30;
input int     DeviationFilter = 5;
input int     BackstepFilter  = 3;
input int     DepthTrade      = 30;
input int     DeviationTrade  = 5;
input int     BackstepTrade   = 3;
extern int    MinSizeFibo     = 50;
input double  FiboOpenDeal    = 50.0;
input double  Lot             = 0.2;
input double  TakeProfit1     = 0.23;
input double  TakeProfit2     = 0.618;
input double  StopLoss        = 61.8;
sinput int    Magic           = 12345;
sinput string Com             = "Fibo";

double Zig,Zag,LastLow,LastHigh,LastWave,PrevAsk=0,PrevBid=0,Zig2,Zag2,LastLow2,LastHigh2,LastWave2,Zig3,Zag3,LastLow3,LastHigh3,LastWave3;
int LowBar,HighBar,Impulse,ticket,LowBar2,HighBar2,Impulse2,LowBar3,HighBar3,Impulse3;
bool res;


double ExtHighBufferTF1[];
double ExtLowBufferTF1[];
double ExtHighBufferTF2[];
double ExtLowBufferTF2[];

int lastTF1barIndex = int(TimeCurrent())/PeriodSeconds(TFTRADE)-1;
int lastTF2barIndex = int(TimeCurrent())/PeriodSeconds(TFFIBOFILTER)-1;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(Digits==3 || Digits==5)
     {
      MinSizeFibo*=10;
     };
     
   ArrayResize(ExtHighBufferTF1, 1000);
   ArrayResize(ExtLowBufferTF1, 1000);
   ArrayResize(ExtHighBufferTF2, 1000);
   ArrayResize(ExtLowBufferTF2, 1000);
   ArrayInitialize(ExtHighBufferTF1, 0.0);
   ArrayInitialize(ExtLowBufferTF1, 0.0);
   ArrayInitialize(ExtHighBufferTF2, 0.0);
   ArrayInitialize(ExtLowBufferTF2, 0.0);
   for(int i=0; i<1000; i++){
      ExtHighBufferTF1[i] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 1, i+1);
      ExtLowBufferTF1[i] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 2, i+1);
      ExtHighBufferTF2[i] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 1, i+1);
      ExtLowBufferTF2[i] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 2, i+1);
      if(ExtHighBufferTF1[i] == EMPTY_VALUE){
         ExtHighBufferTF1[i] = 0.0;
      }
      if(ExtLowBufferTF1[i] == EMPTY_VALUE){
         ExtLowBufferTF1[i] = 0.0;
      }
      if(ExtHighBufferTF2[i] == EMPTY_VALUE){
         ExtHighBufferTF2[i] = 0.0;
      }
      if(ExtLowBufferTF2[i] == EMPTY_VALUE){
         ExtLowBufferTF2[i] = 0.0;
      }
   }

     
     
     
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   ////////////////////////////////////////
   //ZigZag Cache
   ////////////////////////////////////////
   static double TF1low = DBL_MAX;
   static double TF1high = 0.0;
   static double TF2low = DBL_MAX;
   static double TF2high = 0.0;

   //UpdateIndicatorBars();
   int tf1barIndex = int(TimeCurrent())/PeriodSeconds(TFTRADE);
   int tf2barIndex = int(TimeCurrent())/PeriodSeconds(TFFIBOFILTER);
   
   bool zigZagChanged = false;
   
   if(tf1barIndex > lastTF1barIndex){
      int ExtHighBufferTF1ArraySize = ArraySize(ExtHighBufferTF1);
      ArrayResize(ExtHighBufferTF1, ExtHighBufferTF1ArraySize+1);
      ArrayResize(ExtLowBufferTF1, ExtHighBufferTF1ArraySize+1);
      for(int i=ExtHighBufferTF1ArraySize; i>0; --i){
         ExtHighBufferTF1[i] = ExtHighBufferTF1[i-1];
         ExtLowBufferTF1[i] = ExtLowBufferTF1[i-1];
      }
      ExtHighBufferTF1[0] = 0.0;
      ExtLowBufferTF1[0] = 0.0;
      ExtHighBufferTF1[1] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 1, 1);
      ExtLowBufferTF1[1] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 2, 1);
      if(ExtHighBufferTF1[1] == EMPTY_VALUE){
         ExtHighBufferTF1[1] = 0.0;
      }
      if(ExtLowBufferTF1[1] == EMPTY_VALUE){
         ExtLowBufferTF1[1] = 0.0;
      }
      TF1low = DBL_MAX;
      TF1high = 0.0;
      lastTF1barIndex = tf1barIndex;
      zigZagChanged = true;
   }
   if(tf2barIndex > lastTF2barIndex){
      int ExtHighBufferTF2ArraySize = ArraySize(ExtHighBufferTF2);
      double ExtHighBufferTF2tmp[];
      double ExtLowBufferTF2tmp[];
      ArrayCopy(ExtHighBufferTF2tmp, ExtHighBufferTF2, 0, 0, ExtHighBufferTF2ArraySize);
      ArrayCopy(ExtLowBufferTF2tmp, ExtLowBufferTF2, 0, 0, ExtHighBufferTF2ArraySize);
      ArrayResize(ExtHighBufferTF2, ExtHighBufferTF2ArraySize+1);
      ArrayResize(ExtLowBufferTF2, ExtHighBufferTF2ArraySize+1);
      for(int i=ExtHighBufferTF2ArraySize; i>0; --i){
         ExtHighBufferTF2[i] = ExtHighBufferTF2tmp[i-1];
         ExtLowBufferTF2[i] = ExtLowBufferTF2tmp[i-1];
      }
      ExtHighBufferTF2[0] = 0.0;
      ExtLowBufferTF2[0] = 0.0;
      ExtHighBufferTF2[1] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 1, 1);
      ExtLowBufferTF2[1] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 2, 1);
      if(ExtHighBufferTF2[1] == EMPTY_VALUE){
         ExtHighBufferTF2[1] = 0.0;
      }
      if(ExtLowBufferTF2[1] == EMPTY_VALUE){
         ExtLowBufferTF2[1] = 0.0;
      }
      TF2low = DBL_MAX;
      TF2high = 0.0;
      lastTF2barIndex = tf2barIndex;
      zigZagChanged = true;
   }
   
   double TF1LowCurrent[];
   double TF1HighCurrent[];
   double TF2LowCurrent[];
   double TF2HighCurrent[];
   CopyLow(NULL, TFTRADE, 0, 1, TF1LowCurrent);
   CopyHigh(NULL, TFTRADE, 0, 1, TF1HighCurrent);
   CopyLow(NULL, TFFIBOFILTER, 0, 1, TF2LowCurrent);
   CopyHigh(NULL, TFFIBOFILTER, 0, 1, TF2HighCurrent);
   
   if((TF1LowCurrent[0] < TF1low) || (TF1HighCurrent[0] > TF1high)){
      ExtHighBufferTF1[0] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 1, 0);
      ExtLowBufferTF1[0] = iCustom(NULL, TFTRADE, "ZigZag", DepthTrade, DeviationTrade, BackstepTrade, 2, 0);
      if(ExtHighBufferTF1[0] == EMPTY_VALUE){
         ExtHighBufferTF1[0] = 0.0;
      }
      if(ExtLowBufferTF1[0] == EMPTY_VALUE){
         ExtLowBufferTF1[0] = 0.0;
      }
      TF1low = TF1LowCurrent[0];
      TF1high = TF1HighCurrent[0];
      zigZagChanged = true;
   }
   if((TF2LowCurrent[0] < TF2low) || (TF2HighCurrent[0] > TF2high)){
      ExtHighBufferTF2[0] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 1, 0);
      ExtLowBufferTF2[0] = iCustom(NULL, TFFIBOFILTER, "ZigZag", DepthFilter, DeviationFilter, BackstepFilter, 2, 0);
      if(ExtHighBufferTF2[0] == EMPTY_VALUE){
         ExtHighBufferTF2[0] = 0.0;
      }
      if(ExtLowBufferTF2[0] == EMPTY_VALUE){
         ExtLowBufferTF2[0] = 0.0;
      }
      TF2low = TF2LowCurrent[0];
      TF2high = TF2HighCurrent[0];
      zigZagChanged = true;
   }
   ////////////////////////////////////////
   //End of ZigZag Cache
   ////////////////////////////////////////
  
  
  
   if(iBars(Symbol(),TFTRADE)<50)
     {
      Print("Not enough bars in history, at least 50.");
      return;
     }
//---
   for(int i=0; i<1000; i++)
     {
      //Zig=iCustom(NULL,0,"ZigZag",Depth,Deviation,Backstep,2,i);
      Zig=ExtLowBufferTF1[i];
      if(Zig!=0) {LastLow=Zig; LowBar=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      //Zag=iCustom(NULL,0,"ZigZag",Depth,Deviation,Backstep,1,i);
      Zag=ExtHighBufferTF1[i];
      if(Zag!=0) {LastHigh=Zag; HighBar=i; break;}
     }
//---

   if(Zig>Zag) LastWave=NormalizeDouble((LastLow-LastHigh)/Point,Digits);
   if(Zig<Zag) LastWave=NormalizeDouble((LastHigh-LastLow)/Point,Digits);

   if(LowBar>HighBar) Impulse=1;// 
   if(LowBar<HighBar) Impulse=2;// 
                                //Print(Up,Dn);
//---
   if(Impulse==1)
     {
      ObjectDelete("Fibo");
      ObjectCreate("Fibo",OBJ_FIBO,0,iTime(Symbol(),0,LowBar),LastLow,iTime(Symbol(),0,HighBar),LastHigh);
      ObjectSet("Fibo",OBJPROP_COLOR,clrRed);
      ObjectSet("Fibo",OBJPROP_WIDTH,1);
      ObjectSet("Fibo",OBJPROP_STYLE,2);
     }
//---
   if(Impulse==2)
     {
      ObjectDelete("Fibo");
      ObjectCreate("Fibo",OBJ_FIBO,0,iTime(Symbol(),0,HighBar),LastHigh,iTime(Symbol(),0,LowBar),LastLow);
      ObjectSet("Fibo",OBJPROP_COLOR,clrRed);
      ObjectSet("Fibo",OBJPROP_WIDTH,1);
      ObjectSet("Fibo",OBJPROP_STYLE,2);
     };
     
   for(int i=0; i<1000; i++)
     {
      //Zig2=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,2,i);
      Zig2=ExtLowBufferTF2[i];
      if(Zig2!=0) {LastLow2=Zig2; LowBar2=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      //Zag2=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,1,i);
      Zag2=ExtHighBufferTF2[i];
      if(Zag2!=0) {LastHigh2=Zag2; HighBar2=i; break;}
     }
//---

   if(Zig2>Zag2) LastWave2=NormalizeDouble((LastLow2-LastHigh2)/Point,Digits);
   if(Zig2<Zag2) LastWave2=NormalizeDouble((LastHigh2-LastLow2)/Point,Digits);

   if(LowBar2>HighBar2) Impulse2=1;// 
   if(LowBar2<HighBar2) Impulse2=2;// 
     

//Print(LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits));

   if(Impulse==1 && Impulse2==1 && LastWave>MinSizeFibo && CountBuy()==0)
     {
      if(Ask<=LastHigh-NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits) && PrevAsk>=LastHigh-NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits))
        {
         if(AccountFreeMarginCheck(Symbol(),OP_BUY,Lot)<=0){Print("Not enough money.");return;}
         ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,0,0,0,Com,Magic,0,clrNONE);
        }
     }

   if(Impulse==2 && Impulse2==2 && LastWave>MinSizeFibo && CountSell()==0)
     {
      if(Bid>=LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits) && PrevBid<=LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits))
        {
         if(AccountFreeMarginCheck(Symbol(),OP_SELL,Lot)<=0){Print("Not enough money.");return;}
         ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,0,0,0,Com,Magic,0,clrNONE);
        }
     }
//---

  for(int i=0; i<1000; i++)
     {
      //Zig3=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,2,i);
      Zig3=ExtLowBufferTF2[i];
      if(Zig3!=0) {LastLow3=Zig3; LowBar3=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      //Zag3=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,1,i);
      Zag3=ExtHighBufferTF2[i];
      if(Zag3!=0) {LastHigh3=Zag3; HighBar3=i; break;}
     }
//---

   if(Zig3>Zag3) LastWave3=NormalizeDouble((LastLow3-LastHigh3)/Point,Digits);
   if(Zig3<Zag3) LastWave3=NormalizeDouble((LastHigh3-LastLow3)/Point,Digits);

   if(LowBar3>HighBar3) Impulse3=1;// 
   if(LowBar3<HighBar3) Impulse3=2;// 
//---
   
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY&&Impulse==1)
              {
               if(Bid<=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }
               else if(Bid<=LastHigh-NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),(OrderLots()/2),Bid,0,clrNONE);
                 } 
               else if(Bid<=LastHigh-NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }    
              }

            if(OrderType()==OP_SELL&&Impulse==2)
              {
                if(Ask>=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }
                else if(Ask>=LastLow+NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),(OrderLots()/2),Ask,0,clrNONE);
                 } 
                else if(Ask>=LastLow+NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }   
              }
            if(OrderType()==OP_BUY&&Impulse3==1)
              {
              if(iClose(_Symbol,TFSL,0)<=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }
              } 
            if(OrderType()==OP_SELL&&Impulse3==2)
              {
              if(iClose(_Symbol,TFSL,0)>=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }
              
              }   
           }
     }

   PrevAsk=Ask;
   PrevBid=Bid;
  }
//+------------------------------------------------------------------+
int CountBuy()
  {
   int count = 0;
   for(int i = OrdersTotal() - 1; i >= 0; i --)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic)
            count++;
        }
     }
   return (count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountSell()
  {
   int count = 0;
   for(int i = OrdersTotal() - 1; i >= 0; i --)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic)
            count++;
        }
     }
   return (count);
  }
//+------------------------------------------------------------------+
